!
! REQ --- evaluate the right side of the system of linear
!       differential equations of first order
! Robin Santra, Christian Buth
! 03 Apr 2007
!


      subroutine REQ(t, norig, ndot, K, M, init)
      use ridgidrotor
      implicit none

!       integer neq
!       parameter(neq = 500)
!       parameter(neq = 20)
!       parameter(neq = 30)
!       integer Kmax
!       parameter(Kmax = 1)
!       parameter(Kmax = 13)
!       parameter(Kmax = 20)
!       integer Mmax
!       parameter(Mmax = 1)
!       parameter(Mmax = 13)
!       parameter(Mmax = 20)
      real(dblprec) t
      complex(dblprec) norig(neq), ndot(neq)
      complex(dblprec) phase
!       real*8 Vmat(-2:2,neq,-Mmax:Mmax,-Kmax:Kmax)
!       real*8 power,tau,PtoI,PulseEnergy
!       real*8 power
      real(dblprec) intens
!       ,A,B
!       integer K,M,init,neq1,Kmax1,Mmax1
      integer K, M, init, indr, i, l, q

!       common /laser/ tau,PtoI,PulseEnergy
!       common /molec/ K,M,init,neq1,Kmax1,Mmax1,A,B,Vmat

!       if (neq.ne.neq1) then
!          write(*,*) 'in REQ.F90'
!          write(*,*) 'set neq equal to ',neq1
!          stop
!       end if
!       if (Kmax.ne.Kmax1) then
!          write(*,*) 'in REQ.F90'
!          write(*,*) 'set Kmax equal to ',Kmax1
!          stop
!       end if
!       if (Mmax.ne.Mmax1) then
!          write(*,*) 'in REQ.F90'
!          write(*,*) 'set Mmax equal to ',Mmax1
!          stop
!       end if

      ! Local intensity in atomic units:
      intens = laserpower(t,tau,PulseEnergy)*PtoI
      ! multiply intensity by -2*pi*alpha
      intens = -0.0458506d0*intens

      indr = 1
      i = init + indr - 1
      ndot(indr) = (0.d0,0.d0)
      do q = 0,2
         l = i + q
         phase = RotConstB * real(i*(i+1)-l*(l+1), dblprec)
         phase = (0.d0,1.d0)*phase*t
         phase = exp(phase)
         ndot(indr) = ndot(indr) +              &
     &        Vmat(q,indr,M,K)*phase*norig(indr+q)
      end do
      ndot(indr) = ndot(indr)*(0.d0,-1.d0)*intens

      indr = 2
      i = init + indr - 1
      ndot(indr) = (0.d0,0.d0)
      do q = -1,2
         l = i + q
         phase = RotConstB * real(i*(i+1)-l*(l+1), dblprec)
         phase = (0.d0,1.d0)*phase*t
         phase = exp(phase)
         ndot(indr) = ndot(indr) +              &
     &        Vmat(q,indr,M,K)*phase*norig(indr+q)
      end do
      ndot(indr) = ndot(indr)*(0.d0,-1.d0)*intens

      do indr = 3, neq-2
         i = init + indr - 1
         ndot(indr) = (0.d0,0.d0)
         do q = -2,2
            l = i + q
            phase = RotConstB * real(i*(i+1)-l*(l+1), dblprec)
            phase = (0.d0,1.d0)*phase*t
            phase = exp(phase)
            ndot(indr) = ndot(indr) +             &
     &           Vmat(q,indr,M,K)*phase*norig(indr+q)
         end do
         ndot(indr) = ndot(indr)*(0.d0,-1.d0)*intens
      end do

      indr = neq-1
      i = init + indr - 1
      ndot(indr) = (0.d0,0.d0)
      do q = -2,1
         l = i + q
         phase = RotConstB * real(i*(i+1)-l*(l+1), dblprec)
         phase = (0.d0,1.d0)*phase*t
         phase = exp(phase)
         ndot(indr) = ndot(indr) +              &
     &        Vmat(q,indr,M,K)*phase*norig(indr+q)
      end do
      ndot(indr) = ndot(indr)*(0.d0,-1.d0)*intens

      indr = neq
      i = init + indr - 1
      ndot(indr) = (0.d0,0.d0)
      do q = -2,0
         l = i + q
         phase = RotConstB * real(i*(i+1)-l*(l+1), dblprec)
         phase = (0.d0,1.d0)*phase*t
         phase = exp(phase)
         ndot(indr) = ndot(indr) +              &
     &        Vmat(q,indr,M,K)*phase*norig(indr+q)
      end do
      ndot(indr) = ndot(indr)*(0.d0,-1.d0)*intens
      end subroutine REQ
