!
! rk4 --- Fourth order Runge-Kutta differential equation system solver
! Robin Santra, Christian Buth
! 03 Apr 2007
!


      subroutine rk4(neq, n, t0, tc, tf, dt, work, K, M, init)
      use fortrantl
!       use ridgidrotor
      implicit none

      integer neq
      complex(dblprec) n(neq)
      real(dblprec) t0,tc,tf,dt
      complex(dblprec) work(neq,5)
      integer i, K, M, init

      call REQ(t0, n, work(1,1), K, M, init)

      do i = 1, neq
        work(i,5) = n(i) + (0.5d0,0.d0) * cmplx(dt,0.0D0,dblprec)*work(i,1)
      end do

      call REQ(tc, work(1,5), work(1,2), K, M, init)

      do i = 1, neq
        work(i,5) = n(i) + (0.5d0,0.d0) * cmplx(dt,0.0D0,dblprec)*work(i,2)
      end do

      call REQ(tc, work(1,5), work(1,3), K, M, init)

      do i = 1, neq
        work(i,5) = n(i) + cmplx(dt,0.0D0,dblprec) * work(i,3)
      end do

      call REQ(tf, work(1,5), work(1,4), K, M, init)

      do i = 1, neq
        work(i,5) = work(i,1) + (2.d0,0.d0) * work(i,2)  &
     &       + (2.d0,0.d0) * work(i,3) + work(i,4)
        n(i) = n(i) + work(i,5) * cmplx(dt/6.d0,0.0D0,dblprec)
      end do
      end subroutine rk4
