!
! pick --- pick eigenvalues out of a complex spectrum
! Christian Buth
! 14 Sep 2006
!
! Version V1.0.0: 14 Sep 2006 (Pick eigenvalue which is
!       closest to the origin)
!


      program pick
      use fortrantl
      implicit none

      integer i, neigen
      real(dblprec) eta, mind, dis
      complex(dblprec) closest
      complex(dblprec), allocatable :: spectrum(:)

      read(*,*) neigen
      read(*,*) eta
      allocate(spectrum(neigen))

      mind = huge(1.0D0)
      do i=1, neigen
        read(*,*) spectrum(i)
        dis = abs(spectrum(i))
        if (dis < mind) then
          mind = dis
          closest = spectrum(i)
        end if
      end do

      write(*,*) 'The closest eigenvalue, distance ', mind,  &
     &           ', is ', closest

      deallocate(spectrum)
      end program pick
