
      subroutine mtrxcalc( Cevecin, nbasis, ntot, X, Big )
      use fortrantl
      implicit none

!! This subroutine is to be used when multiplying a nonsymmetric matrix
!!  in <f|M|f> multiplication

  INTEGER nbasis, ntot, j, k
  REAL(dblprec) :: Cevecin(nbasis, ntot), X(-5:5, nbasis), Big(ntot,ntot)
  REAL(dblprec), ALLOCATABLE :: Imdt(:,:)

  ALLOCATE( Imdt(nbasis, ntot) )

  CALL Av_FEband( nbasis, X, Cevecin, Imdt, ntot )

  DO j = 1, ntot
    DO k = 1,ntot
       Big(j,k) = dot_product( Cevecin(:,j), Imdt(:,k) )
    END DO
  END DO


  RETURN
  END SUBROUTINE mtrxcalc

!!*************************************************************************!!

  SUBROUTINE symtrxcalc( Cevecin, nbasis, ntot, X, Big )
      use fortrantl
   implicit none

!! This subroutine is to be used when multiplying a symmetric matrix
!!  in <f|M|f> multiplication

  INTEGER nbasis, ntot, j, k
  REAL(dblprec) :: Cevecin(nbasis, ntot), X(-5:5, nbasis), Big(ntot,ntot)
  REAL(dblprec), ALLOCATABLE :: Imdt(:,:)

  ALLOCATE( Imdt(nbasis, ntot) )

  CALL Av_FEband( nbasis, X, Cevecin, Imdt, ntot )

  DO j = 1, ntot
    DO k = 1, j
       Big(j,k) = dot_product( Cevecin(:,j), Imdt(:,k) )
       Big(k,j) = Big(j,k)
    END DO
  END DO


RETURN
END SUBROUTINE symtrxcalc

!!*************************************************************************!!

SUBROUTINE asymtrxcalc( Cevecin, nbasis, ntot, X, Big )
      use fortrantl
 implicit none

!! This subroutine is to be used when multiplying an antisymmetric matrix
!!  in <f|M|f> multiplication

  INTEGER nbasis, ntot, j, k
  REAL(dblprec) :: Cevecin(nbasis, ntot), X(-5:5, nbasis), Big(ntot,ntot)
  REAL(dblprec), ALLOCATABLE :: Imdt(:,:)

  ALLOCATE( Imdt(nbasis, ntot) )

  CALL Av_FEband( nbasis, X, Cevecin, Imdt, ntot )

  DO j = 1, ntot
    DO k = 1, j
       Big(j,k) = dot_product( Cevecin(:,j), Imdt(:,k) )

         IF ( k /= j ) THEN
           Big(k,j) = -1.d0*Big(j,k)
         END IF

    END DO
  END DO


RETURN
END SUBROUTINE asymtrxcalc

!!*************************************************************************!!
