!
! writeatom --- write the matrix representation in eigenfunctions of the
!       Hamiltonian of various operators to disk
! 16 Jan 2006
! Christian Buth
!

      subroutine writeatom(nstate, nvlnc, nl, Eng, ndcntfin, SESdip, SESfTf,  &
     &          SESpot, SESWbig)
      use fortrantl
      implicit none

      integer nstate, nvlnc, nl, ndcntfin(nstate,nl)
      real(dblprec) Eng(nstate,nl)
      complex(dblprec), intent(in) :: SESdip(nstate,nl,nstate,nl), SESfTf(nstate,nstate,nl), &
     &                                SESpot(nstate,nstate,nl), SESWbig(nstate,nstate,nl)
      integer i, j, k, l

      open(18, file='atom.dat', status='replace')
      write(18,21) nl, nstate, nvlnc

      do k = 1, nl
        do j = 1, nstate
          write(18,22) Eng(j,k), ndcntfin(j,k)
        end do
      end do

      write(18,23) ((((SESdip(i,j,k,l),i=1,nstate),j=1,nl), &
     &          k=1,nstate),l=1,nl)
      write(18,23) (((SESfTf(i,j,k),i=1,nstate),j=1,nstate),k=1,nl)
      write(18,23) (((SESpot(i,j,k),i=1,nstate),j=1,nstate),k=1,nl)
      write(18,23) (((SESWbig(i,j,k),i=1,nstate),j=1,nstate),k=1,nl)

 21   format(3i4)
 22   format(d22.15,i5)
 23   format(3d22.15)

      close(18)
      end subroutine writeatom
