SUBROUTINE mtrxbuild( Cevec, nbasis, nstate, nvlnc, ntot, nl, xnd, Eng, &
                      ndcntfin, ngrd, egfxn, xh, c, eta )

 USE FiniteElements
  implicit none

 INTEGER :: nbasis, nstate, nvlnc, ntot, nl, ngrd, ndcntfin(nstate,nl)
 REAL(kind=8) :: Cevec(nbasis,nstate,nl), Eng(nstate,nl)
 REAL(kind=8) :: egfxn(ngrd,nstate,nl)
 REAL(kind=8) :: xh, c, eta
 TYPE(FEBnodes) :: xnd
 INTEGER :: i, j, k, l
 REAL(kind=8), ALLOCATABLE :: Dple(:,:), Dpbig(:,:),  dipmat(:,:,:,:)
 REAL(kind=8), ALLOCATABLE :: Wbig(:,:,:)
 REAL(kind=8), ALLOCATABLE :: CoulInt(:)
 INTEGER :: it0, it1, it2, it3, ict, counterr,counterc

   CALL system_clock( it0, ict )
   Print*,'Building matrices using eigenvectors'

!! Create dipole matrix (analytic)

   ALLOCATE( Dple(-5:5,nbasis), Dpbig(ntot,ntot) )
   CALL Dmtrx( Dple, xnd )
   CALL symtrxcalc( Cevec, nbasis, ntot, Dple, Dpbig )

   ! Replacement for dipole matrix (numeric)
!    ALLOCATE( dipmat(nstate,nl,nstate,nl) )
!    CALL RissDmtrx(dipmat, nstate, nl, egfxn, ngrd, xh)

!! Create W matrix (numerical)
!! Note that W is diagonal with respect to l

   ALLOCATE( Wbig(nstate,nstate,nl) )
   CALL Wmtrx( Wbig, nstate, nl, egfxn, ngrd, xh, c )
   Print*,'Done'

   CALL system_clock(it1)
   Print*,'Time is', ( (it1-it0)*1.d0/ict )
   CALL system_clock( it0, ict )

   Print*,'Writing'
   OPEN(18,FILE='atom.dat',STATUS='REPLACE')
   WRITE(18,21) nl, nstate, nvlnc

   DO k = 1, nl
     DO j = 1, nstate
        WRITE(18,22) Eng(j,k), ndcntfin(j,k)
        write(95,*) Eng(j,k)*27.2114d0, ndcntfin(j,k)
     END DO
   END DO

!      write(18,23) ((((SESdip(i,j,k,l),i=1,nstate),j=1,nl), &
!     &          k=1,nstate),l=1,nl)
   WRITE(18,23) ((((cmplx(Dpbig(i+(j-1)*nstate,k+(l-1)*nstate), 0.0D0,  &
     &          kind(0.0D0)), i=1,nstate),j=1,nl),k=1,nstate),l=1,nl)
!   write(18,23) ((((cmplx(dipmat(i,j,k,l), 0.0D0, kind(0.0D0)),  &
!     &          i=1,nstate),j=1,nl),k=1,nstate),l=1,nl)
!      write(18,23) (((SESfTf(i,j,k),i=1,nstate),j=1,nstate),k=1,nl)
   WRITE(18,23) (((cmplx(0.0D0, 0.0D0, kind(0.0D0)),i=1,nstate),j=1,nstate),k=1,nl)
!      write(18,23) (((SESpot(i,j,k),i=1,nstate),j=1,nstate),k=1,nl)
   WRITE(18,23) (((cmplx(0.0D0, 0.0D0, kind(0.0D0)),i=1,nstate),j=1,nstate),k=1,nl)
!      write(18,23) (((SESWbig(i,j,k),i=1,nstate),j=1,nstate),k=1,nl)
   WRITE(18,23) (((cmplx(0.0D0, -eta * Wbig(i,j,k), kind(0.0D0)),i=1,nstate),j=1,nstate),k=1,nl)

21 FORMAT(3i4)
22 FORMAT(d22.15,i5)
23 FORMAT(3d22.15)

   CLOSE(18)
   Print*,'Done'
   CALL system_clock(it1)
   Print*,'Time is', ( (it1-it0)*1.d0/ict )
END SUBROUTINE mtrxbuild
