SUBROUTINE sqrtmesh( rf, nodestot, xnd, nbasis, leftright )
 USE FiniteElements
  implicit none

  INTEGER :: nodestot
  REAL(kind=8) :: rf
  INTEGER :: nbasis, leftright(2)
  TYPE(FEBnodes) :: xnd
  INTEGER :: j
  REAL(kind=8), ALLOCATABLE :: nodes(:)
  REAL(kind=8) :: xnf, hx, nodespace


!! rf is the length of the grid , with the first node at r=0
!! nodestot is the input of the desired number of nodes  

 
   ALLOCATE( nodes(10000) )

   xnf=dsqrt(rf)
   hx = xnf/dble(nodestot-1)
  
   DO j = 1, nodestot
     nodes(j) = (j-1)*hx
     nodes(j) = ( nodes(j) )**2
   END DO
 

!! CreateNodes creates xnd, a data structure containing information 
!!  about finite element nodes
   
   CALL CreateNodes(xnd,nodes,nodestot,leftright)
   
   nbasis = numbasfun(xnd)

   Print*, 'The number of nodes is', nodestot
   Print*,'The number of basis functions is',nbasis

!! Calculate the spacing between the last two nodes

   nodespace = nodes(nodestot) - nodes(nodestot-1)

   Print*,'The spacing between the last two f. e. nodes is', nodespace


   DEALLOCATE( nodes )

RETURN
END SUBROUTINE sqrtmesh 

